-----------------------------------------------------------------------------
-- the magic
-----------------------------------------------------------------------------
local function Shared(self, unit)
	self.colors = oUF_colors
	self:RegisterForClicks("LeftButtonDown", "RightButtonDown")
	self:SetScript('OnEnter', UnitFrame_OnEnter)
	self:SetScript('OnLeave', UnitFrame_OnLeave)

	self:SetAttribute('type2', 'menu')
    
	self:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8", insets = {top = -1, left = -1, bottom = -1, right = -1}})
	self:SetBackdropColor(0,0,0)    
-----------------------------------------------------------------------------
-- health
-----------------------------------------------------------------------------
    local health = CreateFrame('StatusBar', nil, self)
    health:SetPoint("TOPLEFT")
	health:SetPoint("TOPRIGHT")
	health:SetHeight(22)
	health:SetStatusBarTexture(unitframeconfig["Statusbar Texture"])
    health:SetStatusBarColor(.1,.1,.1)
    
    health.frequentUpdates = true
    health.colorDisconnected = false
    health.colorClass = false
    health.Smooth = true
	self.Health = health
-----------------------------------------------------------------------------
-- healthbackground
-----------------------------------------------------------------------------
	health.bg = health:CreateTexture(nil, 'BORDER')
	health.bg:SetAllPoints(health)
	health.bg:SetTexture(unitframeconfig["Statusbar Texture"])
	health.bg:SetVertexColor(.4,.4,.4)
	health.bg.multiplier = 0.3
    self.Health.bg = health.bg
-----------------------------------------------------------------------------
-- Panels
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Healthborder
-----------------------------------------------------------------------------
    local healthborder = CreateFrame("frame","healthborder",health)
    healthborder:SetBackdrop({
        bgFile = "Interface\\Buttons\\WHITE8x8", 
        edgeFile = "Interface\\Buttons\\WHITE8x8", 
        tile = false,
        tileSize = 0,
        edgeSize = 1, 
        insets = {
        left = -1,
        right = -1,
        top = -1,
        bottom = -1
        }
    });
    healthborder:SetBackdropColor(0, 0, 0, 1);
    healthborder:SetBackdropBorderColor(0.2, 0.2, 0.2);
    healthborder:SetPoint("TOPLEFT",-2,2)
    healthborder:SetPoint("BOTTOMRIGHT",2,-2)
    healthborder:SetBackdropColor(0,0,0,1)
    healthborder:SetFrameLevel(self:GetFrameLevel())
    healthborder:SetFrameStrata(self:GetFrameStrata())
-----------------------------------------------------------------------------
-- Panel at the bottom
-----------------------------------------------------------------------------
    self.Panel = CreateFrame("Frame", self:GetName().."Panel", health)
    self.Panel:SetPoint("TOP", health, "BOTTOM", 0, -1)
    self.Panel:SetSize(self:GetWidth()+4, 17)
    self.Panel:SetBackdrop({
        bgFile = "Interface\\Buttons\\WHITE8x8", 
        edgeFile = "Interface\\Buttons\\WHITE8x8", 
        tile = false,
        tileSize = 0,
        edgeSize = 1, 
        insets = {
        left = -1,
        right = -1,
        top = -1,
        bottom = -1
        }
    });
    self.Panel:SetBackdropColor(0, 0, 0, 1);
    self.Panel:SetBackdropBorderColor(0.2, 0.2, 0.2);
    self.Panel:SetFrameLevel(self:GetFrameLevel())
    self.Panel:SetFrameStrata(self:GetFrameStrata())
    
    local bg = self.Panel:CreateTexture(nil, 'BORDER')
    bg:SetPoint("TOPLEFT", 2, -2)
    bg:SetPoint("BOTTOMRIGHT", -2, 2)
    bg:SetTexture(unitframeconfig["Statusbar Texture"]);
    bg:SetVertexColor(0.1, 0.1, 0.1)
-----------------------------------------------------------------------------
-- Targetborder
-----------------------------------------------------------------------------
    self.Border = CreateFrame("Frame", nil, self);
	self.Border:SetBackdrop({
		bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Buttons\\WHITE8x8",
		title = false,
		tileSize = 0,
		edgeSize = 1,
		insets = {
			left = -1,
			right = -1,
			top = -1,
			bottom = -1
		}
	})
	self.Border:SetPoint("TOPLEFT",-2,2);
	self.Border:SetPoint("BOTTOMRIGHT",2,0);
	self.Border:SetFrameStrata(self:GetFrameStrata());
	self.Border:SetFrameLevel(self:GetFrameLevel()+1);
	self.Border:SetBackdropBorderColor(0.31, 0.45, 0.63);
	self.Border:SetBackdropColor(0,0,0,0);
	self.Border:Hide();
-----------------------------------------------------------------------------
-- healthvalue
-----------------------------------------------------------------------------
	health.value = SetFontString(health)
	health.value:SetPoint("RIGHT", self.Panel, "RIGHT", -4, 0);
	health.PostUpdate = PostUpdateHealthRaid
-----------------------------------------------------------------------------
-- powervalue
-----------------------------------------------------------------------------
	local power = CreateFrame("StatusBar", nil, self)
	self.Power = power
	power.value = SetFontString(health)
	power.value:SetPoint("LEFT", self.Panel, "LEFT", 4, 0);
	power.PreUpdate = PreUpdatePower
	power.PostUpdate = PostUpdatePower
-----------------------------------------------------------------------------
-- Name
-----------------------------------------------------------------------------
    local Name = SetFontString(health)
    Name:SetPoint("CENTER", self.Panel)
    Name:SetJustifyH("LEFT")
    Name:SetFont(unitframeconfig["Font"], unitframeconfig["Font size"], unitframeconfig["Font style"]);
    self:Tag(Name, '[getnamecolor][nameshort][shortclassification]')
    self.Name = Name
-----------------------------------------------------------------------------
-- Raidicons
-----------------------------------------------------------------------------
    local RaidIcon = health:CreateTexture(nil, 'OVERLAY')
    RaidIcon:SetHeight(18)
    RaidIcon:SetWidth(18)
    RaidIcon:SetPoint('CENTER', self, 'TOP')
    self.RaidIcon = RaidIcon
-----------------------------------------------------------------------------
-- Register targetchange
-----------------------------------------------------------------------------
	self:RegisterEvent("PLAYER_TARGET_CHANGED", function(self)
		if ( UnitIsUnit("target", self.unit) ) then
			self.Border:Show();
		else
			self.Border:Hide();
		end
	end);
-----------------------------------------------------------------------------
-- Debuffhighlight
-----------------------------------------------------------------------------	
    CreateHighlight(self)
-----------------------------------------------------------------------------
-- Range
-----------------------------------------------------------------------------
    local range = {insideAlpha = 1, outsideAlpha = 0.3}
    self.Range = range
-----------------------------------------------------------------------------
-- Healcomm
-----------------------------------------------------------------------------
    CreateHealComm(self)
-----------------------------------------------------------------------------
-- Aurawatch
-----------------------------------------------------------------------------
    CreateWatch(self)

    return self
end

oUF:RegisterStyle('Arena', Shared)
oUF:Factory(function(self)
oUF:SetActiveStyle("Arena")	
	local iArena = self:SpawnHeader("iArena", nil, "custom [@raid6,exists] hide;show",
        'oUF-initialConfigFunction', [[
        local header = self:GetParent()
        self:SetWidth(header:GetAttribute('initial-width'))
        self:SetHeight(header:GetAttribute('initial-height'))
        RegisterUnitWatch(self)
        ]],
        'initial-width', 200,
        'initial-height', 40,	
        "showParty", true,
        "showRaid", true,
        "showPlayer", true, 
        "showSolo", false,
        "yOffset", 8,
        "point", "BOTTOM",
        "groupFilter", "1",
        "groupingOrder", "1",
        "groupBy", "GROUP",
        "maxColumns", 1,
        "unitsPerColumn", 5,
        "columnSpacing", 3,
        "columnAnchorPoint", "TOP"	
	)
	local GroupAnchor = CreateFrame("Frame", UIParent)
	GroupAnchor:SetHeight(1)
	GroupAnchor:SetWidth(iPlayer:GetWidth()/2)
	GroupAnchor:SetPoint("LEFT", iPlayer, "TOP", 0, 100)
	GroupAnchor:SetPoint("RIGHT", iPlayer, "TOPRIGHT", 0, 100)
	iArena:SetPoint("BOTTOMRIGHT", GroupAnchor, "CENTER", -250, 60)
    iArena:SetSize(200, 29)
end)

