-----------------------------------------------------------------------------
-- the magic
-----------------------------------------------------------------------------
local function Shared(self, unit)
	self.colors = oUF_colors
	self:RegisterForClicks("LeftButtonDown", "RightButtonDown")
	self:SetScript('OnEnter', UnitFrame_OnEnter)
	self:SetScript('OnLeave', UnitFrame_OnLeave)

	self:SetAttribute('type2', 'menu')
    
	self:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8", insets = {top = -1, left = -1, bottom = -1, right = -1}})
	self:SetBackdropColor(0,0,0)    
-----------------------------------------------------------------------------
-- health
-----------------------------------------------------------------------------
    local health = CreateFrame('StatusBar', nil, self)
    health:SetPoint("TOPLEFT")
	health:SetPoint("TOPRIGHT")
	health:SetHeight(35)
	health:SetStatusBarTexture(unitframeconfig["Statusbar Texture"])
    health:SetStatusBarColor(.1,.1,.1)
    
    health.frequentUpdates = true
    health.colorDisconnected = false
    health.colorClass = false
    health.Smooth = true
	self.Health = health
-----------------------------------------------------------------------------
-- healthbackground
-----------------------------------------------------------------------------
	health.bg = health:CreateTexture(nil, 'BORDER')
	health.bg:SetAllPoints(health)
	health.bg:SetTexture(unitframeconfig["Statusbar Texture"])
	health.bg:SetVertexColor(.4,.4,.4)
	health.bg.multiplier = 0.3
    self.Health.bg = health.bg
-----------------------------------------------------------------------------
-- Panels
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- Healthborder
-----------------------------------------------------------------------------
    local healthborder = CreateFrame("frame","healthborder",health)
    healthborder:SetBackdrop({
        bgFile = "Interface\\Buttons\\WHITE8x8", 
        edgeFile = "Interface\\Buttons\\WHITE8x8", 
        tile = false,
        tileSize = 0,
        edgeSize = 1, 
        insets = {
        left = -1,
        right = -1,
        top = -1,
        bottom = -1
        }
    });
    healthborder:SetBackdropColor(0, 0, 0, 1);
    healthborder:SetBackdropBorderColor(0.2, 0.2, 0.2);
    healthborder:SetPoint("TOPLEFT",-2,2)
    healthborder:SetPoint("BOTTOMRIGHT",2,-2)
    healthborder:SetBackdropColor(0,0,0,1)
    healthborder:SetFrameLevel(self:GetFrameLevel())
    healthborder:SetFrameStrata(self:GetFrameStrata())
-----------------------------------------------------------------------------
-- Targetborder
-----------------------------------------------------------------------------
    self.Border = CreateFrame("Frame", nil, self);
	self.Border:SetBackdrop({
		bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Buttons\\WHITE8x8",
		title = false,
		tileSize = 0,
		edgeSize = 1,
		insets = {
			left = -1,
			right = -1,
			top = -1,
			bottom = -1
		}
	})
	self.Border:SetPoint("TOPLEFT",-2,2);
	self.Border:SetPoint("BOTTOMRIGHT",2,-2);
	self.Border:SetFrameStrata(self:GetFrameStrata());
	self.Border:SetFrameLevel(self:GetFrameLevel()+1);
	self.Border:SetBackdropBorderColor(0.31, 0.45, 0.63);
	self.Border:SetBackdropColor(0,0,0,0);
	self.Border:Hide();
-----------------------------------------------------------------------------
-- healthvalue
-----------------------------------------------------------------------------
	health.value = SetFontString(health)
	health.value:SetPoint("BOTTOM", self.Health, "BOTTOM", 0, 2);
	health.PostUpdate = PostUpdateHealthRaid
-----------------------------------------------------------------------------
-- Name
-----------------------------------------------------------------------------
    local Name = SetFontString(health)
    Name:SetPoint("BOTTOM", health, "CENTER", 0, 1)
    self:Tag(Name, '[getnamecolor][nameshort][shortclassification]')
    self.Name = Name
-----------------------------------------------------------------------------
-- Raidicons
-----------------------------------------------------------------------------
    local RaidIcon = health:CreateTexture(nil, 'OVERLAY')
    RaidIcon:SetHeight(18)
    RaidIcon:SetWidth(18)
    RaidIcon:SetPoint('CENTER', self, 'TOP')
    self.RaidIcon = RaidIcon
-----------------------------------------------------------------------------
-- Register targetchange
-----------------------------------------------------------------------------
	self:RegisterEvent("PLAYER_TARGET_CHANGED", function(self)
		if ( UnitIsUnit("target", self.unit) ) then
			self.Border:Show();
		else
			self.Border:Hide();
		end
	end);
-----------------------------------------------------------------------------
-- Debuffhighlight
-----------------------------------------------------------------------------	
    CreateHighlight(self)
-----------------------------------------------------------------------------
-- Range
-----------------------------------------------------------------------------
    local range = {insideAlpha = 1, outsideAlpha = 0.3}
    self.Range = range
-----------------------------------------------------------------------------
-- Healcomm
-----------------------------------------------------------------------------
    CreateHealComm(self)
-----------------------------------------------------------------------------
-- Aurawatch
-----------------------------------------------------------------------------
    CreateWatch(self)
    
    return self
end

oUF:RegisterStyle('Raid', Shared)
oUF:Factory(function(self)
oUF:SetActiveStyle("Raid")	
	local iRaid = self:SpawnHeader("iRaid", nil, "custom [@raid6,exists] show;hide",
        'oUF-initialConfigFunction', [[
        local header = self:GetParent()
        self:SetWidth(header:GetAttribute('initial-width'))
        self:SetHeight(header:GetAttribute('initial-height'))
        RegisterUnitWatch(self)
        ]],
        'initial-width', 71,
        'initial-height', 35,	
        "showParty", true,
        "showRaid", true,
        "showPlayer", true, 
        "showSolo", false,
        "xOffset", -7,
        "point", "RIGHT",
        "groupFilter", "1,2,3,4,5,6,7,8",
		'groupingOrder', '1,2,3,4,5,6,7,8',
        "groupBy", "GROUP",
        "maxColumns", 5,
        "unitsPerColumn", 5,
        "columnSpacing", 7,
        "columnAnchorPoint", "TOP"	
	)
    local raidAnchor = CreateFrame("Frame", UIParent)
	raidAnchor:SetHeight(300)
	raidAnchor:SetWidth(500)
	raidAnchor:SetPoint("CENTER", UIParent, "CENTER", 325, -170)    
	iRaid:SetPoint("TOPLEFT", raidAnchor, 50, 0)
    iRaid:SetSize(71, 35)
end)

