-----------------------------------------------------------------------------
-- The Magic
-----------------------------------------------------------------------------
local Layout = function(self, unit)
-----------------------------------------------------------------------------
-- Some cool functions
-----------------------------------------------------------------------------
	self.colors = oUF_colors
	self.menu = menu
	self:RegisterForClicks("LeftButtonDown", "RightButtonDown")
	self:SetAttribute("*type2", "menu")
	self:SetScript('OnEnter', UnitFrame_OnEnter)
	self:SetScript('OnLeave', UnitFrame_OnLeave)
    
    menu(self)
-----------------------------------------------------------------------------
-- Health
-----------------------------------------------------------------------------    
    local health = CreateFrame('StatusBar', self:GetName().."_Health", self);
    health:SetPoint("TOPLEFT")
    health:SetPoint("TOPRIGHT")
    health:SetStatusBarTexture(unitframeconfig["Statusbar Texture"]);
    self.Health = health
-----------------------------------------------------------------------------
-- Health functions
----------------------------------------------------------------------------- 
    health.frequentUpdates = true
    health.Smooth = true
    health.colorTapping = false
    health.colorDisconnected = false
    health.colorClass = false
    health:SetStatusBarColor(0.1, 0.1, 0.1, 1);
-----------------------------------------------------------------------------
-- Health Background
----------------------------------------------------------------------------- 
    local healthBG = health:CreateTexture(nil, 'BORDER')
    healthBG:SetAllPoints()
    healthBG:SetTexture(139/255, 0, 0, 1);
    self.Health.bg = healthBG
-----------------------------------------------------------------------------
-- Power
-----------------------------------------------------------------------------
    local power = CreateFrame('StatusBar', nil, self);
    power:SetStatusBarTexture(unitframeconfig["Statusbar Texture"]);
    self.Power = power
-----------------------------------------------------------------------------
-- Power Background
-----------------------------------------------------------------------------
    local powerBG = power:CreateTexture(nil, 'BORDER')
    powerBG:SetAllPoints(power);
    powerBG:SetTexture(unitframeconfig["Statusbar Texture"]);
    powerBG.multiplier = 0.5
    self.Power.bg = powerBG
-----------------------------------------------------------------------------
-- Power functions
----------------------------------------------------------------------------- 
    power.frequentUpdates = 0.1 -- (for rogues and cats)
    power.Smooth = true 
    power.colorDisconnected = true
    power.colorClass = true
    power.colorClassNPC = false
    power.colorTapping = true
-----------------------------------------------------------------------------
-- Health Value
-----------------------------------------------------------------------------
    health.value = SetFontString(health);
    health.value:SetPoint("RIGHT", health, "RIGHT", -4, 0);
    health.PostUpdate = PostUpdateHealth
-----------------------------------------------------------------------------
-- Power Value
-----------------------------------------------------------------------------    
    power.value = SetFontString(health);
    power.value:SetPoint("LEFT", health, "LEFT", 4, 0);
    power.PreUpdate = PreUpdatePower
    power.PostUpdate = PostUpdatePower
-----------------------------------------------------------------------------
-- Name
----------------------------------------------------------------------------- 
    local Name = health:CreateFontString(nil, "OVERLAY")
    Name:SetPoint("CENTER", health, "CENTER", 0, 0);
    Name:SetJustifyH("LEFT")
    Name:SetFont(unitframeconfig["Font"], unitframeconfig["Font size"], unitframeconfig["Font style"]);
    self:Tag(Name, '[getnamecolor][nameshort] [diffcolor][level] [shortclassification]')
    self.Name = Name
-----------------------------------------------------------------------------
-- Masterloot
----------------------------------------------------------------------------- 
    local MasterLooter = self.Health:CreateTexture(nil, "OVERLAY")
    MasterLooter:SetHeight(14);
    MasterLooter:SetWidth(14);
    MasterLooter:SetPoint("TOP",self,0,5);
    self.MasterLooter = MasterLooter
-----------------------------------------------------------------------------
-- Leader
-----------------------------------------------------------------------------
    local Leader = self.Health:CreateTexture(nil, "OVERLAY")
    Leader:SetHeight(14);
    Leader:SetWidth(14);
    Leader:SetPoint("TOPLEFT", 2, 8);
    self.Leader = Leader
-----------------------------------------------------------------------------
-- PvP Icon
-----------------------------------------------------------------------------
    status = SetFontString(health)
    status:SetTextColor(0.69, 0.31, 0.31, 1)
    status:Hide()
    self:Tag(status, "[pvp]")
    self.Status = status
-----------------------------------------------------------------------------
-- Combat Icon
-----------------------------------------------------------------------------
    Combat = health:CreateTexture(nil, "OVERLAY")
    Combat:SetHeight(19)
    Combat:SetWidth(19)
    Combat:SetPoint("CENTER",0,1)
    Combat:SetVertexColor(0.69, 0.31, 0.31)
    Combat:Hide()
    self.Combat = Combat
-----------------------------------------------------------------------------
-- Role Icon
-----------------------------------------------------------------------------
    LFDRole = self.Health:CreateTexture(nil, "OVERLAY")
    LFDRole:SetHeight(19)
    LFDRole:SetWidth(19)
    LFDRole:SetPoint("TOPLEFT",4,1)
    LFDRole:Hide()
    self.LFDRole = LFDRole
-----------------------------------------------------------------------------
-- Phasing
-----------------------------------------------------------------------------
    PhaseIcon = self.Health:CreateTexture(nil, "OVERLAY")
    PhaseIcon:SetHeight(19)
    PhaseIcon:SetWidth(19)
    PhaseIcon:SetPoint("TOPLEFT",4,1)
    PhaseIcon:Hide()
    self.PhaseIcon = PhaseIcon
-----------------------------------------------------------------------------
-- Quest
-----------------------------------------------------------------------------
    QuestIcon = self.Health:CreateTexture(nil, "OVERLAY")
    QuestIcon:SetHeight(19)
    QuestIcon:SetWidth(19)
    QuestIcon:SetPoint("TOPLEFT",4,1)
    QuestIcon:Hide()
    self.QuestIcon = QuestIcon
-----------------------------------------------------------------------------
-- Raid Icon
-----------------------------------------------------------------------------
	RaidIcon = self.Health:CreateTexture(nil, "OVERLAY")
	RaidIcon:SetHeight(20)
	RaidIcon:SetWidth(20)
	RaidIcon:SetPoint("TOP", 6, 8)
    self.RaidIcon = RaidIcon
-----------------------------------------------------------------------------
-- Border
-----------------------------------------------------------------------------
    self.Border = CreateFrame("Frame", self:GetName().."Border", self)
    self.Border:SetPoint("TOPLEFT", -2, 2)
    self.Border:SetPoint("BOTTOMRIGHT", 2, -2)
    self.Border:SetBackdrop({
        bgFile = "Interface\\Buttons\\WHITE8x8", 
        edgeFile = "Interface\\Buttons\\WHITE8x8", 
        tile = false,
        tileSize = 0,
        edgeSize = 1, 
        insets = {
        left = -1,
        right = -1,
        top = -1,
        bottom = -1
        }
    });
    self.Border:SetBackdropColor(0, 0, 0, 1);
    self.Border:SetBackdropBorderColor(0.2, 0.2, 0.2);
    self.Border:SetFrameStrata("BACKGROUND")
    
    if ( unit == "player" or unit == "target" or unit == "focus" ) and ( class == "PRIEST" ) then
        local ws = CreateFrame("StatusBar", self:GetName().."_WeakenedSoul", power)
        ws:SetAllPoints(self.Power)
        ws:SetStatusBarTexture(unitframeconfig["Statusbar Texture"])
        ws:GetStatusBarTexture():SetHorizTile(false)
        ws:SetBackdrop({
            bgFile = "Interface\\Buttons\\WHITE8x8", 
            tile = false,
            tileSize = 0,
            insets = {
            left = 0,
            right = 0,
            top = 0,
            bottom = 0
            }
        });
        ws:SetBackdropColor(0.1, 0.1, 0.1)
        ws:SetStatusBarColor(191/255, 10/255, 10/255)
        
        self.WeakenedSoul = ws
    end;
-----------------------------------------------------------------------------
-- Target
----------------------------------------------------------------------------- 
        if ( unit == "target" ) then

            self:SetWidth(230)
            health:SetHeight(22)
            
            power:SetHeight(6)
            power:SetWidth( self:GetWidth() )
            power:SetPoint("BOTTOM", health, 0, - power:GetHeight() - 1 )   
            
            self:SetHeight( health:GetHeight() + power:GetHeight() + 1 )
            
            self.Panel = CreateFrame("Frame", self:GetName().."Panel", self)
            self.Panel:SetPoint("TOP", self, "BOTTOM", 0, -1)
            self.Panel:SetSize(self:GetWidth()+4, 17)
            self.Panel:SetBackdrop({
                bgFile = "Interface\\Buttons\\WHITE8x8", 
                edgeFile = "Interface\\Buttons\\WHITE8x8", 
                tile = false,
                tileSize = 0,
                edgeSize = 1, 
                insets = {
                left = -1,
                right = -1,
                top = -1,
                bottom = -1
                }
            });
            self.Panel:SetBackdropColor(0, 0, 0, 1);
            self.Panel:SetBackdropBorderColor(0.2, 0.2, 0.2);
            self.Panel:SetFrameStrata("BACKGROUND")
            
            health.value:SetPoint("RIGHT", self.Panel, "RIGHT", -4, 0);
            power.value:SetPoint("LEFT", self.Panel, "LEFT", 4, 0);
            Name:SetPoint("CENTER", self.Panel)
            
            local bg = self.Panel:CreateTexture(nil, 'BORDER')
            bg:SetPoint("TOPLEFT", 2, -2)
            bg:SetPoint("BOTTOMRIGHT", -2, 2)
            bg:SetTexture(unitframeconfig["Statusbar Texture"]);
            bg:SetVertexColor(0.1, 0.1, 0.1)
            
            local healthperc = health:CreateFontString(nil, "OVERLAY")
            healthperc:SetPoint("CENTER", health, "CENTER", 0, 0);
            healthperc:SetJustifyH("LEFT")
            healthperc:SetFont(unitframeconfig["Font"], 20, unitframeconfig["Font style"]);
            self:Tag(healthperc, '[healthperc]')
            self.healthperc = healthperc
            
    -----------------------------------------------------------------------------
    -- Portrait
    -----------------------------------------------------------------------------         
            PortraitBorder = CreateFrame("Frame", self:GetName().."Border",  self)
            PortraitBorder:SetPoint("LEFT", self, "RIGHT", 5, -8)
            PortraitBorder:SetSize(self:GetHeight()+20, self:GetHeight()+20)
            PortraitBorder:SetBackdrop({
                bgFile = "Interface\\Buttons\\WHITE8x8", 
                edgeFile = "Interface\\Buttons\\WHITE8x8", 
                tile = false,
                tileSize = 0,
                edgeSize = 1, 
                insets = {
                left = -1,
                right = -1,
                top = -1,
                bottom = -1
                }
            });
            PortraitBorder:SetBackdropColor(0, 0, 0, 1);
            PortraitBorder:SetBackdropBorderColor(0.2, 0.2, 0.2);
            PortraitBorder:SetFrameStrata("BACKGROUND")
            PortraitBorder:SetFrameLevel(1)
            
            PortraitBorder2 = CreateFrame("Frame", self:GetName().."Border2",  PortraitBorder)
            PortraitBorder2:SetPoint("TOPLEFT", 3, -3)
            PortraitBorder2:SetPoint("BOTTOMRIGHT", -3, 3)
            PortraitBorder2:SetBackdrop({
                bgFile = tex, 
                edgeFile = "Interface\\Buttons\\WHITE8x8", 
                tile = false,
                tileSize = 0,
                edgeSize = 1, 
                insets = {
                left = -1,
                right = -1,
                top = -1,
                bottom = -1
                }
            });
            PortraitBorder2:SetBackdropColor(0.1, 0.1, 0.1, 1);
            PortraitBorder2:SetBackdropBorderColor(0.2, 0.2, 0.2, 0);
            PortraitBorder2:SetFrameStrata("BACKGROUND")
            PortraitBorder2:SetFrameLevel(3)

            local portrait = CreateFrame('PlayerModel', nil, PortraitBorder)
            portrait:SetScript('OnShow', function(self) self:SetCamera(0) end)
            portrait:SetPoint("TOPLEFT", 2, -2)
            portrait:SetPoint("BOTTOMRIGHT", -2, 2)
            portrait:SetFrameStrata("BACKGROUND")
            portrait:SetFrameLevel(4)
            portrait.type = '3D'
            self.Portrait = portrait
    -----------------------------------------------------------------------------
    -- Classicons
    ----------------------------------------------------------------------------- 
            local class = self:CreateTexture(nil, "OVERLAY")
            class:SetPoint("TOPLEFT", PortraitBorder, -1, 2)
            class:SetPoint("BOTTOMRIGHT", PortraitBorder, 1, -1)
            self.ClassIcon = class
    -----------------------------------------------------------------------------
    -- Auratracker
    -----------------------------------------------------------------------------   
            self.AuraTracker = CreateFrame("Frame", nil, self)
            self.AuraTracker:SetAllPoints(portrait)
            self.AuraTracker:SetFrameStrata("HIGH")
                
            self.AuraTracker.icon = self.AuraTracker:CreateTexture(nil, "ARTWORK")
            self.AuraTracker.icon:SetAllPoints(portrait)
            self.AuraTracker.icon:SetWidth(self.Portrait:GetWidth()+1)
            self.AuraTracker.icon:SetHeight(self.Portrait:GetHeight()+1)
            self.AuraTracker.icon:SetTexCoord(0.07,0.93,0.07,0.93)

            self.AuraTracker.text = self.AuraTracker:CreateFontString(nil, 'OVERLAY', 'NumberFontNormal')
            self.AuraTracker.text:SetPoint('CENTER', self.AuraTracker, 0, 0)
                
            self.AuraTracker:SetScript("OnUpdate", updateAuraTrackerTime)
    -----------------------------------------------------------------------------
    -- Auras
    ----------------------------------------------------------------------------- 
            local buffs = CreateFrame("Frame", nil, self);
            local debuffs = CreateFrame("Frame", nil, self);
                    
            buffs:SetPoint("TOPLEFT", self.Panel, "BOTTOMLEFT", 0, -3);

            buffs:SetHeight(26);
            buffs:SetWidth(230);
            buffs.size = 26
            buffs.num = 8

            debuffs:SetHeight(26);
            debuffs:SetWidth(230);
            debuffs:SetPoint("BOTTOMLEFT", self, "TOPLEFT", -2, 5);
            debuffs.size = 40
            debuffs.num = 5

            buffs.spacing = 3
            buffs.PostCreateIcon = PostCreateAura
            buffs.PostUpdateIcon = PostUpdateAura
            self.Buffs = buffs	

            debuffs.spacing = 4
            debuffs["growth-y"] = "UP"
            debuffs["growth-x"] = "RIGHT"
            debuffs.onlyShowPlayer = false -- true or false
            debuffs.PostCreateIcon = PostCreateAura
            debuffs.PostUpdateIcon = PostUpdateAura
            self.Debuffs = debuffs        
        end;
-----------------------------------------------------------------------------
-- Player
----------------------------------------------------------------------------- 
    if ( unit == "player" ) then
        Combat:Show()
        status:Show()
        Name:Hide()
        
        self:SetWidth(230)
        health:SetHeight(22)
        
        power:SetHeight(6)
        power:SetWidth( self:GetWidth() )
        power:SetPoint("BOTTOM", health, 0, - power:GetHeight() - 1 )   
        
        self:SetHeight( health:GetHeight() + power:GetHeight() + 1 )
        
        self.Panel = CreateFrame("Frame", self:GetName().."Panel", self)
        self.Panel:SetPoint("TOP", self, "BOTTOM", 0, -1)
        self.Panel:SetSize(self:GetWidth()+4, 17)
        self.Panel:SetBackdrop({
            bgFile = "Interface\\Buttons\\WHITE8x8", 
            edgeFile = "Interface\\Buttons\\WHITE8x8", 
            tile = false,
            tileSize = 0,
            edgeSize = 1, 
            insets = {
            left = -1,
            right = -1,
            top = -1,
            bottom = -1
            }
        });
        self.Panel:SetBackdropColor(0, 0, 0, 1);
        self.Panel:SetBackdropBorderColor(0.2, 0.2, 0.2);
        self.Panel:SetFrameStrata("BACKGROUND")
        
        health.value:SetPoint("RIGHT", self.Panel, "RIGHT", -4, 0);
        power.value:SetPoint("LEFT", self.Panel, "LEFT", 4, 0);
        status:SetPoint("CENTER", self.Panel, 0, 0)
        
        local bg = self.Panel:CreateTexture(nil, 'BORDER')
        bg:SetPoint("TOPLEFT", 2, -2)
        bg:SetPoint("BOTTOMRIGHT", -2, 2)
        bg:SetTexture(unitframeconfig["Statusbar Texture"]);
        bg:SetVertexColor(0.1, 0.1, 0.1)
-----------------------------------------------------------------------------
-- Portrait
----------------------------------------------------------------------------- 
        PortraitBorder = CreateFrame("Frame", self:GetName().."Border",  self)
        PortraitBorder:SetPoint("RIGHT", self, "LEFT", -5, -8)
        PortraitBorder:SetSize(self:GetHeight()+20, self:GetHeight()+20)
        PortraitBorder:SetBackdrop({
            bgFile = "Interface\\Buttons\\WHITE8x8", 
            edgeFile = "Interface\\Buttons\\WHITE8x8", 
            tile = false,
            tileSize = 0,
            edgeSize = 1, 
            insets = {
            left = -1,
            right = -1,
            top = -1,
            bottom = -1
            }
        });
        PortraitBorder:SetBackdropColor(0, 0, 0, 1);
        PortraitBorder:SetBackdropBorderColor(0.2, 0.2, 0.2);
        PortraitBorder:SetFrameStrata("BACKGROUND")
        PortraitBorder:SetFrameLevel(1)
        
        PortraitBorder2 = CreateFrame("Frame", self:GetName().."Border2",  PortraitBorder)
        PortraitBorder2:SetPoint("TOPLEFT", 3, -3)
        PortraitBorder2:SetPoint("BOTTOMRIGHT", -3, 3)
        PortraitBorder2:SetBackdrop({
            bgFile = tex, 
            edgeFile = "Interface\\Buttons\\WHITE8x8", 
            tile = false,
            tileSize = 0,
            edgeSize = 1, 
            insets = {
            left = -1,
            right = -1,
            top = -1,
            bottom = -1
            }
        });
        PortraitBorder2:SetBackdropColor(0.1, 0.1, 0.1, 1);
        PortraitBorder2:SetBackdropBorderColor(0.2, 0.2, 0.2, 0);
        PortraitBorder2:SetFrameStrata("BACKGROUND")
        PortraitBorder2:SetFrameLevel(3)

        local portrait = CreateFrame('PlayerModel', nil, PortraitBorder)
        portrait:SetScript('OnShow', function(self) self:SetCamera(0) end)
        portrait:SetPoint("TOPLEFT", 2, -2)
        portrait:SetPoint("BOTTOMRIGHT", -2, 2)
        portrait:SetFrameStrata("BACKGROUND")
        portrait:SetFrameLevel(4)
        portrait.type = '3D'
        self.Portrait = portrait
-----------------------------------------------------------------------------
-- Auratracker
-----------------------------------------------------------------------------   
        self.AuraTracker = CreateFrame("Frame", nil, self)
        self.AuraTracker:SetAllPoints(portrait)
        self.AuraTracker:SetFrameStrata("HIGH")
            
        self.AuraTracker.icon = self.AuraTracker:CreateTexture(nil, "ARTWORK")
        self.AuraTracker.icon:SetAllPoints(portrait)
        self.AuraTracker.icon:SetWidth(self.Portrait:GetWidth()+1)
        self.AuraTracker.icon:SetHeight(self.Portrait:GetHeight()+1)
        self.AuraTracker.icon:SetTexCoord(0.07,0.93,0.07,0.93)

        self.AuraTracker.text = self.AuraTracker:CreateFontString(nil, 'OVERLAY', 'NumberFontNormal')
        self.AuraTracker.text:SetPoint('CENTER', self.AuraTracker, 0, 0)
            
        self.AuraTracker:SetScript("OnUpdate", updateAuraTrackerTime)
-----------------------------------------------------------------------------
-- Castbar
-----------------------------------------------------------------------------    
        local castbar = CreateFrame("StatusBar", self:GetName().."_Castbar", self);
        castbar:SetStatusBarTexture(unitframeconfig["Statusbar Texture"]);
        castbar:SetFrameLevel(9);
        castbar:SetFrameStrata("HIGH")
        castbar:SetPoint("BOTTOM", UIParent, 0, 100);
        castbar:SetSize(250, 20)
        castbar:SetStatusBarColor(0.2, 0.2, 0.2)
        
        castbar.time = SetFontString(castbar);
        castbar.time:SetPoint("RIGHT", castbar, "RIGHT", -4, 0);
        castbar.time:SetTextColor(0.84, 0.75, 0.65);
        castbar.time:SetJustifyH("RIGHT")

        castbar.Text = SetFontString(castbar);
        castbar.Text:SetPoint("LEFT", castbar, "LEFT", 4, 0);
        castbar.Text:SetTextColor(0.84, 0.75, 0.65);
        
        local SafeZone = castbar:CreateTexture(nil, "OVERLAY")
        SafeZone:SetTexture(unitframeconfig["Statusbar Texture"])
        SafeZone:SetVertexColor(139/255, 0, 0, 1)
        
        self.Castbar = castbar
        self.Castbar.Time = castbar.time
        self.Castbar.SafeZone = SafeZone
        
        CastbarBorder = CreateFrame("Frame", self:GetName().."Border", castbar)
        CastbarBorder:SetPoint("TOPLEFT", -2, 2)
        CastbarBorder:SetPoint("BOTTOMRIGHT", 2, -2)
        CastbarBorder:SetBackdrop({
            bgFile = "Interface\\Buttons\\WHITE8x8", 
            edgeFile = "Interface\\Buttons\\WHITE8x8", 
            tile = false,
            tileSize = 0,
            edgeSize = 1, 
            insets = {
            left = -1,
            right = -1,
            top = -1,
            bottom = -1
            }
        });
        CastbarBorder:SetBackdropColor(0, 0, 0, 1);
        CastbarBorder:SetBackdropBorderColor(0.2, 0.2, 0.2);
        CastbarBorder:SetFrameStrata("BACKGROUND")
        
        local bg = CastbarBorder:CreateTexture(nil, 'OVERLAY')
        bg:SetPoint("TOPLEFT", 2, -2)
        bg:SetPoint("BOTTOMRIGHT", -2, 2)
        bg:SetTexture(unitframeconfig["Statusbar Texture"]);
        bg:SetVertexColor(0.1, 0.1, 0.1)
-----------------------------------------------------------------------------
-- Combatfeedback
-----------------------------------------------------------------------------  
        local CombatFeedbackText 
        CombatFeedbackText = SetFontString(health, font,16, tags);
        CombatFeedbackText:SetPoint("CENTER", 0, 0);
        CombatFeedbackText.colors = {
            DAMAGE = {0.69, 0.31, 0.31},
            CRUSHING = {0.69, 0.31, 0.31},
            CRITICAL = {0.69, 0.31, 0.31},
            GLANCING = {0.69, 0.31, 0.31},
            STANDARD = {0.84, 0.75, 0.65},
            IMMUNE = {0.84, 0.75, 0.65},
            ABSORB = {0.84, 0.75, 0.65},
            BLOCK = {0.84, 0.75, 0.65},
            RESIST = {0.84, 0.75, 0.65},
            MISS = {0.84, 0.75, 0.65},
            HEAL = {0.33, 0.59, 0.33},
            CRITHEAL = {0.33, 0.59, 0.33},
            ENERGIZE = {0.31, 0.45, 0.63},
            CRITENERGIZE = {0.31, 0.45, 0.63},
        }
        self.CombatFeedbackText = CombatFeedbackText
-----------------------------------------------------------------------------
-- HolyPower
----------------------------------------------------------------------------- 
		if ( class == "PALADIN" ) then
			self.HolyPower = CreateFrame("Frame", nil, self)
			self.HolyPower:SetPoint("CENTER", 0, -250)
			self.HolyPower:SetHeight(30)
			self.HolyPower:SetWidth(90)
			for i = 1, 3 do
				self.HolyPower[i] = CreateFrame("StatusBar", nil, self)
				self.HolyPower[i]:SetStatusBarTexture(unitframeconfig["Statusbar Texture"])
				self.HolyPower[i]:SetStatusBarColor(0, 0, 0, 0.5)
				self.HolyPower[i]:SetHeight(30)
				self.HolyPower[i]:SetWidth(30)
                local HolyPowerBorder = CreateFrame("frame", nil, self.HolyPower[i])
				HolyPowerBorder:SetBackdrop({
                    bgFile = "Interface\\Buttons\\WHITE8x8", 
                    edgeFile = "Interface\\Buttons\\WHITE8x8", 
                    tile = false,
                    tileSize = 0,
                    edgeSize = 1, 
                    insets = {
                    left = -1,
                    right = -1,
                    top = -1,
                    bottom = -1
                    }
                });
                HolyPowerBorder:SetBackdropBorderColor(0, 0, 0);
                HolyPowerBorder:SetBackdropColor(0, 0, 0, 0)
                HolyPowerBorder:SetPoint("TOPLEFT", -1, 1)
                HolyPowerBorder:SetPoint("BOTTOMRIGHT", 1, -1)
				if i == 1 then
					self.HolyPower[i]:SetPoint("CENTER", UIParent, 0, -150)
				elseif i == 2 then
					self.HolyPower[i]:SetPoint("LEFT", self.HolyPower[1], "RIGHT", 5, 0)
                elseif i == 3 then
                    self.HolyPower[i]:SetPoint("RIGHT", self.HolyPower[1], "LEFT", -5, 0)
				end
			end
		end
-----------------------------------------------------------------------------
-- Shards
----------------------------------------------------------------------------- 
		if class == "WARLOCK" then
			self.SoulShards = CreateFrame("Frame", nil, self)
			self.SoulShards:SetPoint("CENTER", 0, -250)
			self.SoulShards:SetHeight(30)
			self.SoulShards:SetWidth(90)
			for i = 1, 3 do
				self.SoulShards[i] = CreateFrame("StatusBar", nil, self)
				self.SoulShards[i]:SetStatusBarTexture(unitframeconfig["Statusbar Texture"])
				self.SoulShards[i]:SetStatusBarColor(0, 0, 0, 0.5)
				self.SoulShards[i]:SetHeight(30)
				self.SoulShards[i]:SetWidth(30)
                local SoulShardsBorder = CreateFrame("frame", nil, self.SoulShards[i])
				SoulShardsBorder:SetBackdrop({
                    bgFile = "Interface\\Buttons\\WHITE8x8", 
                    edgeFile = "Interface\\Buttons\\WHITE8x8", 
                    tile = false,
                    tileSize = 0,
                    edgeSize = 1, 
                    insets = {
                    left = -1,
                    right = -1,
                    top = -1,
                    bottom = -1
                    }
                });
                SoulShardsBorder:SetBackdropBorderColor(0, 0, 0);
                SoulShardsBorder:SetBackdropColor(0, 0, 0, 0)
                SoulShardsBorder:SetPoint("TOPLEFT", -1, 1)
                SoulShardsBorder:SetPoint("BOTTOMRIGHT", 1, -1)
				if i == 1 then
					self.SoulShards[i]:SetPoint("CENTER", UIParent, 0, -150)
				elseif i == 2 then
					self.SoulShards[i]:SetPoint("LEFT", self.SoulShards[1], "RIGHT", 5, 0)
                elseif i == 3 then
                    self.SoulShards[i]:SetPoint("RIGHT", self.SoulShards[1], "LEFT", -5, 0)
				end
			end
        end
-----------------------------------------------------------------------------
-- Totems
----------------------------------------------------------------------------- 
		if IsAddOnLoaded("oUF_TotemBar") and class == "SHAMAN" then
			self.TotemBar = {}
			self.TotemBar.Destroy = true
			for i = 1, 4 do
				self.TotemBar[i] = CreateFrame("StatusBar", nil, self)
				self.TotemBar[i]:SetStatusBarTexture(unitframeconfig["Statusbar Texture"])
				self.TotemBar[i]:SetBackdrop({
                    bgFile = "Interface\\Buttons\\WHITE8x8", 
                    tile = false,
                    tileSize = 0,
                    edgeSize = 1, 
                    insets = {
                    left = -1,
                    right = -1,
                    top = -1,
                    bottom = -1
                    }
                });
				self.TotemBar[i]:SetBackdropColor(0, 0, 0)
				self.TotemBar[i]:SetHeight(7)
				self.TotemBar[i]:SetWidth((150-2)/4)
				self.TotemBar[i]:SetMinMaxValues(0, 1)
				if i == 1 then
					self.TotemBar[i]:SetPoint("BOTTOMRIGHT", self.Health, "TOPRIGHT", 0, 5)
				else
					self.TotemBar[i]:SetPoint("RIGHT", self.TotemBar[i-1], "LEFT", -1, 0)
				end
				self.TotemBar[i].bg = self.TotemBar[i]:CreateTexture(nil, "BORDER")
				self.TotemBar[i].bg:SetAllPoints(self.TotemBar[i])
				self.TotemBar[i].bg:SetTexture(unitframeconfig["Statusbar Texture"])
				self.TotemBar[i].bg.multiplier = 0.3
			end
		end
-----------------------------------------------------------------------------
-- Runes
----------------------------------------------------------------------------- 
		if class == "DEATHKNIGHT" then
			self.Runes = CreateFrame("Frame", nil, self)
			self.Runes:SetPoint("BOTTOMRIGHT", self.Health, "TOPRIGHT", 0, 5)
			self.Runes:SetHeight(10)
			self.Runes:SetWidth(150)
			for i = 1, 6 do
				self.Runes[i] = CreateFrame("StatusBar", nil, self)
				self.Runes[i]:SetStatusBarTexture(unitframeconfig["Statusbar Texture"])
				self.Runes[i]:SetHeight(10)
				self.Runes[i]:SetWidth((150-5)/6)
				self.Runes[i]:SetBackdrop({
                    bgFile = "Interface\\Buttons\\WHITE8x8", 
                    tile = false,
                    tileSize = 0,
                    edgeSize = 1, 
                    insets = {
                    left = -1,
                    right = -1,
                    top = -1,
                    bottom = -1
                    }
                });
				self.Runes[i]:SetBackdropColor(0, 0, 0)
				if i == 1 then
					self.Runes[i]:SetPoint("BOTTOMRIGHT", self.Health, "TOPRIGHT", 0, 5)
				else
					self.Runes[i]:SetPoint("RIGHT", self.Runes[i-1], "LEFT", -1, 0)
				end
				self.Runes[i].bg = self.Runes[i]:CreateTexture(nil, "BORDER")
				self.Runes[i].bg:SetAllPoints(self.Runes[i])
				self.Runes[i].bg:SetTexture(unitframeconfig["Statusbar Texture"])
				self.Runes[i].bg.multiplier = 0.3
			end
		end
    end;
-----------------------------------------------------------------------------
-- targettarget
-----------------------------------------------------------------------------   
    if unit == "targettarget" then
        power:Hide()
        power.value:Hide()
        health.value:Hide()
        
        self:SetWidth(100)
        self:SetHeight(13)

        health:SetWidth(self:GetWidth())
        health:SetHeight(self:GetHeight())
        
        -- Auras
        local debuffs = CreateFrame("Frame", nil, self);

        debuffs:SetHeight(13);
        debuffs:SetWidth(100);
        debuffs.size = 20
        debuffs.spacing = 6.5
        debuffs.num = 4

        debuffs:SetPoint("TOPLEFT", health, "TOPLEFT", -2, 25);
        debuffs.initialAnchor = "TOPLEFT"
        debuffs["growth-y"] = "UP"
        debuffs.PostCreateIcon = PostCreateAura
        debuffs.PostUpdateIcon = PostUpdateAura
        self.Debuffs = debuffs
        
        self:Tag(Name, '[getnamecolor][namemedium]')
    end;
-----------------------------------------------------------------------------
-- focus
-----------------------------------------------------------------------------
    if unit == "focus" then
    
        self:SetWidth(230)
        health:SetHeight(22)
        
        power:SetHeight(6)
        power:SetWidth( self:GetWidth() )
        power:SetPoint("BOTTOM", health, 0, - power:GetHeight() - 1 )   
        
        self:SetHeight( health:GetHeight() + power:GetHeight() + 1 )
        
        self.Panel = CreateFrame("Frame", self:GetName().."Panel", self)
        self.Panel:SetPoint("TOP", self, "BOTTOM", 0, -1)
        self.Panel:SetSize(self:GetWidth()+4, 17)
        self.Panel:SetBackdrop({
            bgFile = "Interface\\Buttons\\WHITE8x8", 
            edgeFile = "Interface\\Buttons\\WHITE8x8", 
            tile = false,
            tileSize = 0,
            edgeSize = 1, 
            insets = {
            left = -1,
            right = -1,
            top = -1,
            bottom = -1
            }
        });
        self.Panel:SetBackdropColor(0, 0, 0, 1);
        self.Panel:SetBackdropBorderColor(0.2, 0.2, 0.2);
        self.Panel:SetFrameStrata("BACKGROUND")
        
        health.value:SetPoint("RIGHT", self.Panel, "RIGHT", -4, 0);
        power.value:SetPoint("LEFT", self.Panel, "LEFT", 4, 0);
        Name:SetPoint("CENTER", self.Panel)
        
        local bg = self.Panel:CreateTexture(nil, 'BORDER')
        bg:SetPoint("TOPLEFT", 2, -2)
        bg:SetPoint("BOTTOMRIGHT", -2, 2)
        bg:SetTexture(unitframeconfig["Statusbar Texture"]);
        bg:SetVertexColor(0.1, 0.1, 0.1)
        
        local healthperc = health:CreateFontString(nil, "OVERLAY")
        healthperc:SetPoint("CENTER", health, "CENTER", 0, 0);
        healthperc:SetJustifyH("LEFT")
        healthperc:SetFont(unitframeconfig["Font"], 20, unitframeconfig["Font style"]);
        self:Tag(healthperc, '[healthperc]')
        self.healthperc = healthperc
-----------------------------------------------------------------------------
-- Auras
----------------------------------------------------------------------------- 
        local debuffs = CreateFrame("Frame", nil, self);

        debuffs:SetHeight(26);
        debuffs:SetWidth(230);
        debuffs.size = 40
        debuffs.num = 5
        debuffs.spacing = 4
        
        debuffs:SetPoint("BOTTOMLEFT", self, "TOPLEFT", -2, 5);
        debuffs["growth-y"] = "UP"
        debuffs["growth-x"] = "RIGHT"
        debuffs.onlyShowPlayer = false -- true or false

        debuffs.PostCreateIcon = PostCreateAura
        debuffs.PostUpdateIcon = PostUpdateAura
        self.Debuffs = debuffs 
    end;
-----------------------------------------------------------------------------
-- pet
-----------------------------------------------------------------------------
    if unit == "pet" then
        power.value:Hide()
        health.value:Hide()
        
        self:SetWidth(100)
        health:SetHeight(12)
        power:SetHeight(1)
        power:SetWidth( self:GetWidth() )
        power:SetPoint("BOTTOM", health, 0, - power:GetHeight() - 1 )   
        self:SetHeight( health:GetHeight() + power:GetHeight() + 1 )
        power.colorHappiness = true
        
        self:Tag(Name, '[getnamecolor][namemedium]')
    end;
-----------------------------------------------------------------------------
-- Arena
----------------------------------------------------------------------------- 
    if (unit and unit:find("arena%d")) then
        self:SetWidth(230)
        health:SetHeight(22)
        
        power:SetHeight(8)
        power:SetWidth( self:GetWidth() )
        power:SetPoint("BOTTOM", health, 0, - power:GetHeight() - 1 )   
        
        self:SetHeight( health:GetHeight() + power:GetHeight() + 1 )
-----------------------------------------------------------------------------
-- looks like Tukui or Caith Oo
-----------------------------------------------------------------------------
        self.Panel = CreateFrame("Frame", self:GetName().."Panel", self)
        self.Panel:SetPoint("TOP", self, "BOTTOM", 0, -1)
        self.Panel:SetSize(self:GetWidth()+4, 17)
        self.Panel:SetBackdrop({
            bgFile = "Interface\\Buttons\\WHITE8x8", 
            edgeFile = "Interface\\Buttons\\WHITE8x8", 
            tile = false,
            tileSize = 0,
            edgeSize = 1, 
            insets = {
            left = -1,
            right = -1,
            top = -1,
            bottom = -1
            }
        });
        self.Panel:SetBackdropColor(0, 0, 0, 1);
        self.Panel:SetBackdropBorderColor(0.2, 0.2, 0.2);
        self.Panel:SetFrameStrata("BACKGROUND")
        
        health.value:SetPoint("RIGHT", self.Panel, "RIGHT", -4, 0);
        power.value:SetPoint("LEFT", self.Panel, "LEFT", 4, 0);
        Name:SetPoint("CENTER", self.Panel)
        
        local bg = self.Panel:CreateTexture(nil, 'BORDER')
        bg:SetPoint("TOPLEFT", 2, -2)
        bg:SetPoint("BOTTOMRIGHT", -2, 2)
        bg:SetTexture(unitframeconfig["Statusbar Texture"]);
        bg:SetVertexColor(0.1, 0.1, 0.1)
-----------------------------------------------------------------------------
-- oUF_Talents
----------------------------------------------------------------------------- 
        self.Talents = SetFontString(self.Health, font, 14, "THINOUTLINE")
        self.Talents:SetTextColor(1,0,0)
        self.Talents:SetPoint("BOTTOM", self.Health, 0, -2)
-----------------------------------------------------------------------------
-- Auras
----------------------------------------------------------------------------- 
		local debuffs = CreateFrame("Frame", nil, self);
		debuffs:SetHeight(26);
		debuffs:SetWidth(200);
		debuffs:SetPoint('LEFT', self, 'RIGHT', 5, 0);
		debuffs.size = 26
		debuffs.num = 5
		debuffs.spacing = 2
		debuffs.initialAnchor = 'LEFT'
		debuffs.PostCreateIcon = PostCreateAura
		debuffs.PostUpdateIcon = PostUpdateAura
        debuffs["growth-x"] = "RIGHT"
        debuffs["growth-y"] = "DOWN"
        debuffs.onlyShowPlayer = false
        self.Debuffs = debuffs	

-----------------------------------------------------------------------------
-- Portrait
----------------------------------------------------------------------------- 
        PortraitBorder = CreateFrame("Frame", self:GetName().."Border",  self)
        PortraitBorder:SetPoint("RIGHT", self, "LEFT", -5, 0)
        PortraitBorder:SetSize(self:GetHeight()+4, self:GetHeight()+4)
        PortraitBorder:SetBackdrop({
            bgFile = "Interface\\Buttons\\WHITE8x8", 
            edgeFile = "Interface\\Buttons\\WHITE8x8", 
            tile = false,
            tileSize = 0,
            edgeSize = 1, 
            insets = {
            left = -1,
            right = -1,
            top = -1,
            bottom = -1
            }
        });
        PortraitBorder:SetBackdropColor(0, 0, 0, 1);
        PortraitBorder:SetBackdropBorderColor(0.2, 0.2, 0.2);
        PortraitBorder:SetFrameStrata("BACKGROUND")
        PortraitBorder:SetFrameLevel(1)
        
        PortraitBorder2 = CreateFrame("Frame", self:GetName().."Border2",  PortraitBorder)
        PortraitBorder2:SetPoint("TOPLEFT", 3, -3)
        PortraitBorder2:SetPoint("BOTTOMRIGHT", -3, 3)
        PortraitBorder2:SetBackdrop({
            bgFile = tex, 
            edgeFile = "Interface\\Buttons\\WHITE8x8", 
            tile = false,
            tileSize = 0,
            edgeSize = 1, 
            insets = {
            left = -1,
            right = -1,
            top = -1,
            bottom = -1
            }
        });
        PortraitBorder2:SetBackdropColor(0.1, 0.1, 0.1, 1);
        PortraitBorder2:SetBackdropBorderColor(0.2, 0.2, 0.2, 0);
        PortraitBorder2:SetFrameStrata("BACKGROUND")
        PortraitBorder2:SetFrameLevel(3)

        local portrait = CreateFrame('PlayerModel', nil, PortraitBorder)
        portrait:SetScript('OnShow', function(self) self:SetCamera(0) end)
        portrait:SetPoint("TOPLEFT", 2, -2)
        portrait:SetPoint("BOTTOMRIGHT", -2, 2)
        portrait:SetFrameStrata("BACKGROUND")
        portrait:SetFrameLevel(4)
        portrait.type = '3D'
        self.Portrait = portrait
        
-----------------------------------------------------------------------------
-- Classicons
-----------------------------------------------------------------------------
        local class = self:CreateTexture(nil, "OVERLAY")
        class:SetPoint("TOPLEFT", PortraitBorder, -1, 1)
        class:SetPoint("BOTTOMRIGHT", PortraitBorder, 1, -1)
        self.ClassIcon = class
-----------------------------------------------------------------------------
-- oUF_Trinket
-----------------------------------------------------------------------------
        self.Trinketbg = CreateFrame("Frame", nil, PortraitBorder);
        self.Trinketbg:SetHeight(self:GetHeight()+4);
        self.Trinketbg:SetWidth(self:GetHeight()+4);
        self.Trinketbg:SetPoint("RIGHT", PortraitBorder, "LEFT", -3, 0);				
        self.Trinketbg:SetBackdrop({
            bgFile = "Interface\\Buttons\\WHITE8x8", 
            edgeFile = "Interface\\Buttons\\WHITE8x8", 
            tile = false,
            tileSize = 0,
            edgeSize = 1, 
            insets = {
            left = -1,
            right = -1,
            top = -1,
            bottom = -1
            }
        });
        self.Trinketbg:SetFrameLevel(0);
        self.Trinketbg:SetBackdropColor(0,0,0);
        self.Trinketbg:SetBackdropBorderColor(0.2, 0.2, 0.2);

        self.Trinket = CreateFrame("Frame", nil, self.Trinketbg);
        self.Trinket:SetAllPoints(self.Trinketbg);
        self.Trinket:SetPoint("TOPLEFT", self.Trinketbg, 2, -2);
        self.Trinket:SetPoint("BOTTOMRIGHT", self.Trinketbg, -2, 2);
        self.Trinket:SetFrameLevel(1);
        self.Trinket.trinketUseAnnounce = true
        self.Trinket.trinketUpAnnounce = true
-----------------------------------------------------------------------------
-- Auratracker
-----------------------------------------------------------------------------   
        self.AuraTracker = CreateFrame("Frame", nil, self)
        self.AuraTracker:SetAllPoints(portrait)
        self.AuraTracker:SetFrameStrata("HIGH")
            
        self.AuraTracker.icon = self.AuraTracker:CreateTexture(nil, "ARTWORK")
        self.AuraTracker.icon:SetAllPoints(portrait)
        self.AuraTracker.icon:SetWidth(self.Portrait:GetWidth()+1)
        self.AuraTracker.icon:SetHeight(self.Portrait:GetHeight()+1)
        self.AuraTracker.icon:SetTexCoord(0.07,0.93,0.07,0.93)

        self.AuraTracker.text = self.AuraTracker:CreateFontString(nil, 'OVERLAY', 'NumberFontNormal')
        self.AuraTracker.text:SetPoint('CENTER', self.AuraTracker, 0, 0)
            
        self.AuraTracker:SetScript("OnUpdate", updateAuraTrackerTime)
-----------------------------------------------------------------------------
-- Castbar
-----------------------------------------------------------------------------        
        local castbar = CreateFrame("StatusBar", self:GetName().."_Castbar", self);
        castbar:SetStatusBarTexture(unitframeconfig["Statusbar Texture"]);
        castbar:SetFrameLevel(9);
        castbar:SetFrameStrata("HIGH")
        castbar:SetPoint("TOPLEFT",self.Panel,2,-2);		
        castbar:SetPoint("BOTTOMRIGHT",self.Panel,-2,2);
        castbar:SetStatusBarColor(0.2, 0.2, 0.2)
        
        castbar.time = SetFontString(castbar);
        castbar.time:SetPoint("RIGHT", castbar, "RIGHT", -4, 1);
        castbar.time:SetTextColor(0.84, 0.75, 0.65);
        castbar.time:SetJustifyH("RIGHT")

        castbar.Text = SetFontString(castbar);
        castbar.Text:SetPoint("LEFT", castbar, "LEFT", 4, 1);
        castbar.Text:SetTextColor(0.84, 0.75, 0.65);
        
        local bg = castbar:CreateTexture(nil, 'BORDER')
        bg:SetPoint("TOPLEFT", 2, -2)
        bg:SetPoint("BOTTOMRIGHT", -2, 2)
        bg:SetTexture(unitframeconfig["Statusbar Texture"]);
        bg:SetVertexColor(0.1, 0.1, 0.1)
        
        self.Castbar = castbar
        self.Castbar.Time = castbar.time
    end; -- end of arena
-----------------------------------------------------------------------------
-- Debuffhighlight
-----------------------------------------------------------------------------	
    CreateHighlight(self)
    
    return self
end	-- end of function

BottomBar = CreateFrame("frame", "BottomBar", UIParent)
BottomBar:SetPoint("BOTTOMLEFT",-2,-2)
BottomBar:SetPoint("BOTTOMRIGHT", 1, -1)
BottomBar:SetSize(1, 19)

oUF:RegisterStyle('Itrulia', Layout)
oUF:SetActiveStyle('Itrulia')

oUF:Spawn('player', 'iPlayer'):SetPoint("RIGHT", BottomBar, "TOP", -60,190)
oUF:Spawn('target', 'iTarget'):SetPoint("LEFT", BottomBar, "TOP", 60,190)
oUF:Spawn('targettarget', 'iTargetTarget'):SetPoint("CENTER", BottomBar, "TOP", 0,190)
oUF:Spawn('pet', 'iPet'):SetPoint('BOTTOMRIGHT',iPlayer,'BOTTOMLEFT', -3, 2)
oUF:Spawn('focus', 'iFocus'):SetPoint('BOTTOM', iPlayer, 'TOP', 0, 23)

iFocus:SetMovable(true)
iFocus:RegisterForDrag('LeftButton')
iFocus:SetUserPlaced(true)
iFocus:SetScript('OnDragStart', function(self)
    if (IsShiftKeyDown()) then
        self:StartMoving() 
    end
end)
iFocus:SetScript('OnDragStop', function(self) 
    self:StopMovingOrSizing()
end)

local arena = {}
for i = 1, 5 do
    arena[i] = oUF:Spawn("arena"..i, "iArena"..i);
    if i == 1 then
        arena[i]:SetPoint("BOTTOM", UIParent, "BOTTOM", 352, 411);
    else
        arena[i]:SetPoint("BOTTOM", arena[i-1], "TOP", 0, 25);
    end;
end;